from xtrans_sgmlop import *
"""$Id: extrans.py,v 1.2 2001/01/12 18:21:56 devel Rel $"""

from time import time
import os, string, stat, fphash

import sys

def last_mod(fname):  # useless because we have os.path.getmtime(fname)
    return  os.stat(fname)[stat.ST_MTIME]

def check_for_update(xtransfile, xmlfiles, updatedict, refdate, depxml, depxtrans):
    if depxtrans.has_key(xtransfile):
        xtransdate = max( max(map(last_mod, depxtrans[xtransfile])), last_mod(xtransfile) )
    else:
        xtransdate = last_mod(xtransfile)
    for fi in range(len(xmlfiles)):
        f = xmlfiles[fi] = os.path.abspath(xmlfiles[fi])
        if not updatedict.has_key(f) and (last_mod(f) > refdate or xtransdate > refdate):
            updatedict[f] = 1
            if depxml.has_key(f):
                for df in depxml[f]:
                    updatedict[df] = 1



if __name__ == '__main__':

    st = time();

    narg = len(sys.argv)
    if narg < 2:
        raise "\n\n  usage: "+sys.argv[0]+" [-nomaindep] file.main.xtrans\n"
    if narg == 2:
        filename = sys.argv[1]
        maindep = 1
    else:
        filename = sys.argv[2]
        maindep = 0

    # first parse the main.xtrans file
    print "Reading",filename, "and selecting files to be updated..."
    dirname, basename = os.path.split(filename)
    if dirname:
        os.chdir(dirname)
        print "changed into", dirname
    filein = open (basename)
    defstart = re.compile("(\w+):\s*(\S+)")
    # last successful run date
    try:
        lastsuccess = last_mod("."+filename)
    except:
        lastsuccess =  0
    else:
        # we generally prefer to recompile everything when the main file has been modified
        if lastsuccess < last_mod(filename) and maindep:
            lastsuccess =  0
    # XML files that need to be recompiled
    needupdate = {}
    xmllist = []
    transmap = {}
    mainmap = {}
    targetdir = ""
    targetsubdir = ""
    dbdir = ""
    while 1:
        data = filein.readline()
        if not data:    # end of file
            if xmllist:
                transmap[xtranssource] = xmllist
                check_for_update(xtranssource, xmllist, needupdate, lastsuccess, dependxml, dependxtrans)
            if targetsubdir:
                mainmap[targetdir+'/'+targetsubdir] = transmap
            elif targetdir:
                mainmap[targetdir] = transmap
            else: raise "no 'targetdir' found!"
            break
        if data[0]=='#': continue # skip comments
        m = defstart.match(data)
        if m:
            if xmllist:              # a new statement means the last 'apply' is complete
                transmap[xtranssource] = xmllist
                check_for_update(xtranssource, xmllist, needupdate, lastsuccess, dependxml, dependxtrans)
                xmllist = []
            type = string.lower(m.group(1))
            name = m.group(2)
            # print "found", type, name
            if type == "targetdir": targetdir = name
            elif type == "dbdir":
                dbdir = name
                # open dependency database
                dependxml = fphash.open(dbdir+"/depend_xml.db",'r')
                dependxtrans = fphash.open(dbdir+"/depend_xtrans.db",'r')
            elif type == "targetsubdir":
                if targetsubdir:    # if previous subdir statement, attach collected data to it
                    mainmap[targetdir+'/'+targetsubdir] = transmap
                elif targetdir:
                    mainmap[targetdir] = transmap
                else: raise "Found 'targetsubdir' statement without any targetdir"
                transmap = {}
                targetsubdir = name
            elif type == "apply":
                if not dbdir: raise "No dbdir defined when APPLY statement encountered!"
                xtranssource = os.path.abspath(name)
            else: raise "Unknown type "+type
            continue
        if type == "apply":
            l = string.split(data)
            xmllist.extend(l)

    dependxml.close()
    dependxtrans.close()
    # now process the given files with the appropriate xtrans
    xtrans_objs = []
    parser = XMLParser()
    print "dbdir is", dbdir
    totfiles = len (needupdate)
    if not totfiles:
        raise "Everything is up to date."
    print "Parsing (%d files)..." % totfiles
    for targetdir, transmap in mainmap.items():
        print "  Targetdir:", targetdir
        for xts in transmap.keys():
            files_to_update = []
            for xmlfile in transmap[xts]:
                if needupdate.has_key(xmlfile):
                    files_to_update.append(xmlfile)
            if files_to_update:
                Xtrans = make_Xtrans(xts, dbdir)
                print "    Applying", xts,"[%d file(s) to update]" % len(files_to_update)
                for xmlfile in files_to_update:
                    xtrans_inst = Xtrans()
                    parser.register(xtrans_inst)
                    parser.parseFile(xmlfile, targetdir, dbdir)
                    xtrans_objs.append(xtrans_inst)

    print "Postprocessing (%s groups)..." % len(xtrans_objs)
    for xtrans_inst in xtrans_objs:
        xtrans_inst.postprocess()

    lastsuccess = time()
    try:
        os.utime("."+filename, (lastsuccess, lastsuccess))
    except:
        flagfile = open("."+filename,'w')
        flagfile.write("Do not edit or overwrite this file ! It is a timestamp for eXtrans.")
    print "\nTiming:", lastsuccess - st
